#! /usr/bin/env python3
#  -*- coding: utf-8 -*-
#
# Support module generated by PAGE version 7.6
#  in conjunction with Tcl version 8.6
#    Jan 28, 2024 09:26:48 AM CET  platform: Windows NT

import sys
import tkinter as tk
import tkinter.ttk as ttk
from tkinter.constants import *

import pkt_gui_rcs

from datetime import datetime
import binascii

from utility import Chatterbox

terminale = None
#import time

#****************************************

def main(*args):
    '''Main entry point for the application.'''
    global root
    root = tk.Tk()
    #root.protocol( 'WM_DELETE_WINDOW' , root.destroy) - sostituita in PAGINA
    # Creates a toplevel widget.
    global _top1, _w1
    _top1 = root
    _w1 = pkt_gui_rcs.PAGINA(_top1)

    global PST
    PST = "GENERICI"

    global terminale

    serverName = "localhost"
    serverPort = 8000
    # create TCP socket
    terminale = Chatterbox(serverName, serverPort)
    # connect socket to remote server at (serverName, serverPort)
    terminale.connect()



    root.mainloop()

#*********************************************
    
def PostInserita(*args):
    global PST
    PST = (_w1.PostName.get()) # LEGGE il Testo inserito nel BOX POSTAZIONE

# *****  def attivati dalla selezione dei RadioButton
def NonPartiti(*args):
    StampaRadioValue()

def Ritirati(*args):
    StampaRadioValue()

def Messaggio(*args):
    StampaRadioValue()

# Carica il valore del RadioButton Attivo
def StampaRadioValue():
    global TipoMex
    TipoMex = (_w1.RadioValue.get())
    #print ('RadioValue = ' + str(TipoMex))

# Viene memorizzata la data e l'ora correnti alla chiamata della funzione
def Calendario():
    adesso = datetime.now()
    orario = adesso.strftime("%H:%M:%S")
    data_oggi = adesso.strftime("%d-%m-%Y")
    global oggi
    oggi =(data_oggi+" "+orario)    

# Funzione attivata dal Pulsante TEST
def sendbeacon(*args):
    StampaRadioValue()
    Calendario()
    Beacon = (oggi + " \n" + "MESSAGGIO DI PROVA da Postazione " + PST + "\n")
    #Salvataggio(Beacon)
    Invio_SM(Beacon)

# Funzione attivata dal Pulsante INVIA
def sendtext(*args):
    StampaRadioValue()  #Chiamata alla verifica del RadioButton selezionato
    Calendario()        #Chiamata alla memorizzazione DATA e ORA correnti
    # Carico e cancellazione del testo presente nella finestra TESTO da INVIARE
    TDT = ("\n" + (_w1.TextTX.get('1.0','end')))
    _w1.TextTX.delete('1.0','end') # Cancella il testo presente nella finestra TESTO da INVIARE   

    # Definizione del testo esplicativo del messaggio
    if TipoMex == 1 :
        TestoDaTrasmettere = ("ELENCO NON PARTITI : " + TDT)
    elif TipoMex == 2 :
        TestoDaTrasmettere = ("ELENCO RITIRATI : " + TDT)
    elif TipoMex == 3 :
        TestoDaTrasmettere = ("MESSAGGIO INFORMATIVO: " + TDT)
    
    #Composizione del Messaggio che verà inviato
    global MessaggioCompleto
    MessaggioCompleto = ("Da Postazione " + PST + "  " + oggi + " \n" + TestoDaTrasmettere)
    #Salvataggio(MessaggioCompleto) #Chiamata al salvataggio sul File di LOG
    Invio_SM(MessaggioCompleto)   #Chiamata all'invio del Messaggio

# Apertura File LOG , Scrittura e chiusura
def Salvataggio(X):
    global PST
    LOGS = open("DATI_"+PST+".log", "a")
    LOGS.write(X +"\n")
    LOGS.close()

# COMPOSIZIONE ed INVIO della sequenza di Bites
def Invio_SM(X):       # X contiene il testo da inviare / MessaggioCompleto
    inte1 = chr(0)+chr(0)+chr(0)+chr(0)+chr(77)+chr(0) # parte iniziale intestazione
    intes3 = chr(0)     # parte finale intestazione
    mittente = PST + "_______"   # PST è il nome della Postazione Aggiungo se è meno di 6 caratteri
    mittent1 = mittente[0:6:1]   # Devono essere inviati MAX 6 caratteri
    separatore = chr(0)+chr(0)+chr(0)+chr(0)   # 4 caratteri NULL
    destinatario = "TUTTI_"    # sempre 6 caratteri
    num = len(X)
    numx = num - 1
    #print("Lunghezza: ",str(num))
    XT = X[0:numx:1]   # tolgo il LF finale che non so da dove arriva
    separ7 = chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+chr(0)+chr(0) # 7 caratteri NULL

    b_inte1 = inte1.encode()
    values = 240
    b_inte2 = values.to_bytes(1,'little') # parte intermedia intestazione carattere bastardo
    b_inte3 = intes3.encode()    # fine intestazione
    b_mitte = mittent1.encode()
    b_separ = separatore.encode()
    b_desti = destinatario.encode()
    b_lungh = num.to_bytes(1,'little')  # conversione lunghezza testo in carattere HEX corrispondente
    b_sepa7 = separ7.encode()
    b_messa = XT.encode()   # messaggio vero e proprio
    values = 13
    b_fine = values.to_bytes(1,'little')  # carattere di chiusura
    request = b_inte1 + b_inte2 +b_inte3 + b_mitte + b_separ + b_desti + b_separ + b_lungh + b_sepa7 + b_messa + b_fine
    
    global terminale
    terminale.transmit(request)
    #print("FINE TRASMISSIONE")

    """
    data = ""
    fragment = True
    while fragment:
        fragment = terminale.recv(2048)
        data += fragment.decode('utf-8')
    print( f"Ricevuto: {data}")  


    # print out received data
    x = binascii.hexlify(data) #class byte
    y = str(x,'ascii')       #class str

    print(x) 
    print(y)


    x_unhexed = binascii.unhexlify(x)
    # print(x_unhexed) # Outputs b'xxxxx'

    x_ascii = str(x_unhexed,'ascii')
    print(x_ascii)
    _w1.TestoRicevuto.set(x_ascii)

     # """
    # close socket
    #terminale.close()
        
    
if __name__ == '__main__':
    pkt_gui_rcs.start_up()
